
#include <stdio.h>
#include <stdlib.h>
#include "damsel.h"


static char DMSL_unknown[64];

const char *
DMSLerror_str(damsel_err_t err)
{
    sprintf(DMSL_unknown,"Unknown Error: Unrecognized Damsel error code %5d\n",err.id);

    if (err.id == DMSL_OK.id)
        return "No error";
    else if (err.id == DMSL_ERROR_GENERAL.id)
        return "Damsel general error";
    else if (err.id == DMSL_EINVALLIB.id)
        return "Invalid library";
    else if (err.id == DMSL_EUNINITIALIZED.id)
        return "Damsel uninitialized";
    else if (err.id == DMSL_EHANDLETYPE.id)
        return "Invalid Damsel handle type";
    else if (err.id == DMSL_EMALLOC.id)
        return "Damsel internal malloc failed";
    else if (err.id == DMSL_EMODEL.id)
        return "Invalid Damsel model";
    else if (err.id == DMSL_ECMODE.id)
        return "Invalid file create mode";
    else if (err.id == DMSL_EINVALCONTAINER.id)
        return "Invalid container handle";
    else if (err.id == DMSL_EINVALTAG.id)
        return "Invalid tag";
    else if (err.id == DMSL_ENOTFOUND.id)
	return "Tag not found";
    else
        return DMSL_unknown;
}

