#include "damsel.h"

/* This is the header file of defining parent-child relationship. 
 * in this version we have an in-memory structure to desribe it, 
 * but when we store it in files, we will use tags - and then we can rerieve that information
 * like which child, etc
 * */
 
typedef struct {
  int count; //number of child handles
  int order; //order of child handles, e.g. morton, etc
  damsel_handle parent_handle; // this is app side handle
  damsel_handle *child_handles; // this is app side handle
} damsel_internal_parent_child;

typedef struct {
  int count; //number of child handles
  int order; //order of child handles, e.g. morton, etc
  damsel_handle parent_handle; // this is file side handle
  damsel_handle *child_handles; // this is file side handle
} damsel_infile_parent_child;

/*This function will */
void DMSLparentchild_add(damsel_model m, damsel_handle parent_handle, damsel_handle *child_handles, int count, int order);

int DMSLchild_get_count(damsel_model m, damsel_handle parent_handle);
int DMSLchild_get_childnum(damsel_model m, damsel_handle parent_handle, damsel_handle child_handle);
damsel_handle *DMSLchild_get(damsel_model m, damsel_handle parent_handle);
damsel_handle DMSLparent_get(damsel_model m, damsel_handle child_handle);


