#ifndef _DAMSEL_SUGAR_H
#define _DAMSEL_SUGAR_H
#include <assert.h>
#include <stdio.h>

#define DMSL_CHECK(fn) { damsel_err_t ret; ret = (fn); \
	if (ret.id != DMSL_OK.id) { \
            const char *msg = DMSLerror_str(ret); \
	    fprintf(stderr, "error at %d in %s: %s\n", __LINE__, __func__, msg);\
	    assert(1 == 0); } \
}


/* this doesn't really belong in damsel but it's useful and stupid to rewrite it any time someone needs to work on N-d arrays */
int64_t DMSL_subprod(int ndims, int64_t *dims);

/* I find it easier to keep straight the various tags, handles, and containers
 * with this convienience struct: probably need to further extend this to point
 * to the actual data as well  */

typedef struct damsel_data {
    damsel_handle tag_handle;
    damsel_container tag_container;
    damsel_handle container_id;
    damsel_container container;
} damsel_data;

/* after the hundredth iteration of model/trait, lump into a single routine */
damsel_model DMSLmodel_attached_with_trait(MPI_Comm comm, char *fname, char * mode);

damsel_container DMSLselect_subset_from_tag(damsel_model model, 
	damsel_handle tag_id, int ndims, int64_t * size, int64_t *start, 
	int64_t *count);
#endif
