#include <stdio.h>
#include <mpi.h>
#include "damsel.h"

int main(int argc, char **argv) {
  damsel_handle h;
  int lvl;
  MPI_Init_thread(&argc, &argv, MPI_THREAD_MULTIPLE, &lvl);

  damsel_library lib;
  damsel_err_t err = DMSLlib_init(&lib);

  damsel_model model;
  err = DMSLmodel_create(DAMSEL_HANDLE_TYPE_HANDLE64, &model);

  h= 0x10203;
  damsel_err_t t1 = DMSLtag_define(model, &h, DAMSEL_DATA_TYPE_SHORTINT, "somedata");
  if(t1.id != DMSL_OK.id) {
    printf("could not define first tag.\n");
    exit(1);
  }

  h = 0x10204;
  damsel_err_t t2  = DMSLtag_define(model, &h, DAMSEL_DATA_TYPE_SHORTINT, "somedata");
  if(t2.id != DMSL_OK.id) {
    printf("could not define duplicate tag. exiting with success.");
    exit(0);
  }

  DMSLlib_finalize(lib);
  MPI_Finalize();
  printf("unexpectedly did not get an error defining duplicate tag\n");
  exit(3);
}

