/* This file contains all the variables with known/unknown values 
 * used by FLASH. In this version I am using all the variables from
 * the parallel netcdf file. 
*/
/*************************************************************************/
#include <assert.h>
#include <mpi.h>
#include <unistd.h>
#include "damsel.h"
#include "damsel-internal.h"

#define MAX_BLOCKS 17
	
/*Dimensions from parallel netCDF File, there maybe some unused variables */
	const int total_blocks = 17;
	const int nxb_long = 7; //these three are from netcdf FLASH dimentoins, may not use them at all. SO I may remove them later. 
	const int nyb_long = 5;
	const int nzb_long = 1;
	const int nxb = 6;
	const int nyb = 4;
	const int nzb = 1;
	const int NGID = 15; //need to check this value, Later
	const int NDIM = 2;
	const int dim_2 = 2;
	const int dim_1 = 1;
	const int MAX_STR_LEN = 80;
	const int MDIM = 3;
	
	/*Variables from parallel netCDF File*/
	
	//int runtime_parameters(dim_1); //have to see its usage later
	//int scalars(dim_1);

	/*Variables for AMR Grid Structure*/
	int lrefine[] = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
	// block which child index
	int which_child[] = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
	//int processor_number[total_blocks];

	/*Variables for Solution Data, consider 2D case here and maybe 1 solution variable*/
	double unk[17][24];
      
       /*Defining all the structural information here*/
	
	// block coordinates, will create a blob where each blob is 2*sizeof(double) 
	double block_coords[] = {
	    0.0, 0.0,
	    0.0, 0.0,
	    0.0, 0.0,
	    0.0, 0.0,
	    0.0, 0.0, 
	    0.0, 0.0, 
	    0.0, 0.0,
	    0.0, 0.0, 
	    0.0, 0.0, 
	    0.0, 0.0,
	    0.0, 0.0, 
	    0.0, 0.0, 
	    0.0, 0.0, 
	    0.0, 0.0,
	    0.0, 0.0, 
	    0.0, 0.0,
	    0.0, 0.0, 
	};

	double block_size[] = {
	    0.0, 0.0,
            0.0, 0.0,
            0.0, 0.0,
            0.0, 0.0,
            0.0, 0.0,
            0.0, 0.0,
            0.0, 0.0,
            0.0, 0.0,
            0.0, 0.0,
            0.0, 0.0,
            0.0, 0.0,
            0.0, 0.0,
            0.0, 0.0,
            0.0, 0.0,
            0.0, 0.0,
            0.0, 0.0,
            0.0, 0.0,

	};

/*create a blob of 4*sizeof(double) */
        double bnd_box[] = {
	    0.0, 0.0, 0.0, 0.0,
            0.0, 0.0, 0.0, 0.0,
	    0.0, 0.0, 0.0, 0.0,
	    0.0, 0.0, 0.0, 0.0,
	0.0, 0.0, 0.0, 0.0,
	0.0, 0.0, 0.0, 0.0,
	0.0, 0.0, 0.0, 0.0,
	0.0, 0.0, 0.0, 0.0,
	0.0, 0.0, 0.0, 0.0,
	0.0, 0.0, 0.0, 0.0,
	0.0, 0.0, 0.0, 0.0,
	0.0, 0.0, 0.0, 0.0,
	0.0, 0.0, 0.0, 0.0,
	0.0, 0.0, 0.0, 0.0,
	0.0, 0.0, 0.0, 0.0,
	0.0, 0.0, 0.0, 0.0,
	0.0, 0.0, 0.0, 0.0
	};	

	int gid[] = {
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	}; 

	int nodetype[] ={1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
/*	
	const int block_neighbors[] = {
	    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
	    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	};
*/
	/*Tags per variable per block*/
//const char *tag_name[] = {"dens","eint", "ener", "gamc", "game", "pres", "temp", "velx", "vely", "velz"}; 
